<?php
namespace nulib\ref\ext\spout;

use OpenSpout\Writer\XLSX\Options\HeaderFooter;
use OpenSpout\Writer\XLSX\Options\PageMargin;
use OpenSpout\Writer\XLSX\Options\PageSetup;

class ref_builder_xlsx extends ref_builder {
  const PARAMS_SPOUT = [
   ...parent::PARAMS_SPOUT,
   "->setPageSetup" => [
     PageSetup::class,
     "page_orientation" => "string",
     "page_size" => "string",
     "fit_to_height" => "bool",
     "fit_to_width" => "bool",
     "page_order" => "string",
   ],
   "->setPageMargin" => [
     PageMargin::class,
     "top" => "float",
     "right" => "float",
     "bottom" => "float",
     "left" => "float",
     "header" => "float",
     "footer" => "float",
   ],
   "->setHeaderFooter" => [
     HeaderFooter::class,
     "odd_header" => "string",
     "odd_footer" => "string",
     "even_header" => "string",
     "even_footer" => "string",
     "different_odd_even" => "bool",
   ],
  ];

  const PARAMS_SHEET = [
    ...parent::PARAMS_SHEET,
    "view" => self::PARAMS_SHEET_VIEW,
  ];

  const PARAMS_SHEET_VIEW = [
    "->setFreezeRow" => ["int"],
    "->setFreezeColumn" => ["string"],
    "->setZoomScale" => ["int"],
    "->setShowFormulas" => ["bool"],
    "->setShowGridLines" => ["bool"],
    "->setShowRowColHeaders" => ["bool"],
    "->setShowZeroes" => ["bool"],
    "->setRightToLeft" => ["bool"],
    "->setTabSelected" => ["bool"],
    "->setShowOutlineSymbols" => ["bool"],
    "->setDefaultGridColor" => ["bool"],
    "->setView" => ["string"],
    "->setTopLeftCell" => ["string"],
    "->setColorId" => ["int"],
    "->setZoomScaleNormal" => ["int"],
    "->setZoomScalePageLayoutView" => ["int"],
    "->setWorkbookViewId" => ["int"],
    # copie de parent::PARAMS_SHEET_VIEW
  ];
}
